/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


////////////////////////////////////////////////////////////////////////////
//
// Connection Methods
//
////////////////////////////////////////////////////////////////////////////

#include <libc.h>
#include <stdio.h>
#include "oo7.h"
#include "globals.h"
#include "GenParams.h"

extern int	debugMode;
extern char*	types[NumTypes];

////////////////////////////////////////////////////////////////////////////
//
// Connection Constructor
//
////////////////////////////////////////////////////////////////////////////

Connection::Connection(AtomicPart* fromPart, AtomicPart* toPart)
{
    int size;

    if (debugMode) {
        printf("Connection::Connection(fromId = %d, toId = %d)\n",
            fromPart->id, toPart->id);
    }

    // initialize the simple stuff
    int typeNo = (int) (random() % NumTypes);
    strncpy(type, types[typeNo], TypeSize);
    length = (int) (random() % XYRange);

    from = fromPart;  // establish pointer back to "from" part 
    to = toPart;      // establish forward pointer to "to" part
    (fromPart->to)->add((dbvoid *) this); // establish pointer to connection
    (toPart->from)->add((dbvoid *) this); // establish pointer to connection
}
