/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


////////////////////////////////////////////////////////////////////////////
//
// Module Methods
//
////////////////////////////////////////////////////////////////////////////

#include <libc.h>
#include <stdio.h>

#include "oo7.h"
#include "globals.h"
#include "GenParams.h"
#include "VarParams.h"

extern int	nextComplexAssemblyId;
extern int	debugMode;
extern char*	types[NumTypes];

////////////////////////////////////////////////////////////////////////////
//
// Module Constructor
//
////////////////////////////////////////////////////////////////////////////

Module::Module(dbint modId)
{
    if (debugMode) {
        printf("Module::Module(modId = %d)\n", modId);
    }
        printf("Module::Module(modId = %d)\n", modId);

    // initialize the simple stuff
    id = modId;
    int typeNo = (int) (random() % NumTypes);
    strncpy(type, types[typeNo], TypeSize);
    buildDate = MinModuleDate + 
	(int) (random() % (MaxModuleDate-MinModuleDate+1));
    allBases = new (ModuleSet) Assoc(&ModuleSet);

    man = new (ManualSet) Manual(modId, this);

    // now create the assemblies for the module
    if (NumAssmLevels > 1) {
        int assmId = nextComplexAssemblyId++;
        designRoot = new (ModuleSet) ComplexAssembly (assmId, this, NULL, 1);
    }
}

////////////////////////////////////////////////////////////////////////////
//
// Module Destructor
//
////////////////////////////////////////////////////////////////////////////

Module::~Module()
{
    if (debugMode) {
	printf("Module::~Module(id = %d)\n", id);
   }
   // remove module from extent of all modules
   AllModules.remove (this);
}

////////////////////////////////////////////////////////////////////////////
//
// Module scanManual method
//
////////////////////////////////////////////////////////////////////////////

dbint Module::scanManual()
{
    return (man->searchText('I'));
}

////////////////////////////////////////////////////////////////////////////
//
// Module firstLast method
//
////////////////////////////////////////////////////////////////////////////

dbint Module::firstLast()
{
    return (man->firstLast());
}

