/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <stdio.h>
#include "oo7.h"
#include "StringBtree.h"


// Add a key to the hash table

void StringBtIndex::insert(char * val, dbvoid* ref)
{
    index.insert(val,ref);
}


// member function to look up a record in a hashed file based on its key value
dbvoid* StringBtIndex::lookup(char * val)
{
    dbvoid * ret_ptr;
    str_btree_retrieve look_scan(index,val);
    // this is dubious
    int numvals = 0;
    for (look_scan.next(); !look_scan.eof; look_scan.next())
    {
      return look_scan.cur_elem;
    }
    return 0;
}

// member function to delete a record in a hashed file based on its key value
// returns pointer to object contained in the deleted bucket
// note: this only deletes 1 element, repeated deletes during a scan
// don't work.
dbvoid* StringBtIndex::remove(char * val)
{
    str_btree_retrieve rem_scan(index,val);
    // this is dubious
    dbvoid *ret_ptr = 0;
    for (rem_scan.next(); !rem_scan.eof; rem_scan.next())
    {
       ret_ptr = rem_scan.cur_elem;
       index.remove(rem_scan.cur_keyval, rem_scan.cur_elem);
       return ret_ptr;

    }
    return 0;
}
